<?php
/**
 * @package    Vendor Assign - Order total
 * @version    1.0.0
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2016 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgHikamarketVendorassign_ordertotal extends JPlugin {
	/**
	 *
	 * @param string $subject
	 * @param object $config
	 */
	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	/**
	 *
	 */
	protected function init() {
		if(isset($this->params))
			return;

		$plugin = JPluginHelper::getPlugin('hikamarket', 'vendorassign_ordertotal');
		if(version_compare(JVERSION,'2.5','<')) {
			jimport('joomla.html.parameter');
			$this->params = new JParameter($plugin->params);
		} else {
			$this->params = new JRegistry($plugin->params);
		}
	}

	/**
	 *
	 */
	public function onBeforeProductsVendorAttribution(&$products, &$productObjects, &$order) {
		$this->init();

		// Get the Order/Cart total
		//
		$orderFullPrice = 0.0;
		$orderCurrency = 0;
		if(isset($order->cart->full_total) && !empty($order->cart->full_total->prices)) {
			foreach($order->cart->products as $product){
				$shippingcost += $product->shippingcost;
			}
			$new_tax = ($order->cart->full_total->prices[0]->price_value-$shippingcost)*0.2;
			$old_tax = $order->cart->full_total->prices[0]->taxes['VAT']->tax_amount;
			$order->cart->full_total->prices[0]->taxes['VAT']->tax_amount = $new_tax;
			$order->cart->full_total->prices[0]->price_value_with_tax = $order->cart->full_total->prices[0]->price_value_with_tax - $old_tax + $new_tax;
			$order->cart->full_total->prices[0]->price_value_without_payment_with_tax = $order->cart->full_total->prices[0]->price_value_with_tax;
			$price = reset($order->cart->full_total->prices);
			$orderFullPrice = $price->price_value_with_tax;
			$orderCurrency = (int)@$price->price_currency_id;
		}
		if(isset($order->full_total) && !empty($order->full_total->prices)) {
			foreach($order->products as $product){
				$shippingcost += $product->shippingcost;
			}
			$new_tax = ($order->full_total->prices[0]->price_value-$shippingcost)*0.2;
			$old_tax = $order->full_total->prices[0]->taxes['VAT']->tax_amount;
			$order->full_total->prices[0]->taxes['VAT']->tax_amount = $new_tax;
			$order->full_total->prices[0]->price_value_with_tax = $order->full_total->prices[0]->price_value_with_tax - $old_tax + $new_tax;
			$order->full_total->prices[0]->price_value_without_payment_with_tax = $order->full_total->prices[0]->price_value_with_tax;
			$price = ($order->full_total->prices);
			$orderFullPrice = $price->price_value_with_tax ;
			$orderCurrency = (int)@$price->price_currency_id;
		}
		if(isset($order->order_full_price)) {

			$new_tax = ($order->order_full_total->prices[0]->price_value-$shippingcost)*0.2;
			$old_tax = $order->order_full_total->prices[0]->taxes['VAT']->tax_amount;
			$order->order_full_total->prices[0]->taxes['VAT']->tax_amount = $new_tax;
			$order->order_full_total->prices[0]->price_value_with_tax = $order->order_full_total->prices[0]->price_value_with_tax - $old_tax + $new_tax;
			$order->order_full_total->prices[0]->price_value_without_payment_with_tax = $order->order_full_total->prices[0]->price_value_with_tax;


			$orderFullPrice = (float)hikashop_toFloat($order->order_full_price);
			$orderCurrency = (int)@$order->order_currency_id;
		}

		// Convert total if not the main currency
		$shopConfig = hikashop_config();
		$main_currency = (int)$shopConfig->get('main_currency', 1);
		if(!empty($orderCurrency) && $main_currency != $orderCurrency) {
			$currencyClass = hikashop_get('class.currency');
			$orderFullPrice = $currencyClass->convertUniquePrice($orderFullPrice, $orderCurrency, $main_currency);
		}

		// Select the vendor depending the order total
		$vendor = 0;
		$order_value = (float)hikashop_toFloat($this->params->get('order_value_0', 100));
		if($orderFullPrice < $order_value) {
			$vendor = (int)$this->params->get('vendor_0', 2);
		} else {
			$vendor = (int)$this->params->get('vendor_1', 3);
		}

		$vendors = array();
		if(isset($order->products) && !empty($order->products)){
			foreach($order->products as $k=> $pro){
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				$query->select($db->quoteName(array('vendor_id')));
				$query->from($db->quoteName('#__hikamarket_vendor'));
				$query->where($db->quoteName('vendor_name') . ' = "'. $pro->supplier.'"');
				$db->setQuery($query);
				$user_id = $db->loadResult();
				$vendors[$pro->cart_product_id] = $user_id;
			}
		}
		if(isset($order->cart->products) && !empty($order->cart->products)){
			foreach($order->cart->products as $k=> $pro){
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				$query->select($db->quoteName(array('vendor_id')));
				$query->from($db->quoteName('#__hikamarket_vendor'));
				$query->where($db->quoteName('vendor_name') . ' = "'. $pro->supplier.'"');
				$db->setQuery($query);
				$user_id = $db->loadResult();
				$vendors[$pro->cart_product_id] = $user_id;
			}
		}
		$arr_products = array();
		$shippingcost = 0;
		foreach($products as $k=>&$product) {
			$shippingcost += $product['shippingcost'];
			$old_id = $vendors[$k];
			if(isset($arr_products[$k])){
				$vendors[$k] = $arr_products[$k];
			}
			if(!isset($vendors[$k])){
				$vendors[$k] = 2;
			}
			if(!empty($product['vendor']) && $product['vendor']){
				echo "skipping";
				continue;
			}else{
				$product['vendor'] = (int)$vendors[$k];
				$arr_products[$k] = (int)$vendors[$k];

			}
		}
		unset($product);
	}
}
